%% Start from scatch
clear all
clf;
newEdata=false;
first=0;
if(first==1)
%%  Get constants
load SteelN7\Yale042-029s_info;
D=sig0;
Ds=D/Lx;

%% Load Experimental particle positions
if(newEdata)
  PE=false;
  loadall
  save alldataST_org ppx ppy;
end
load alldataST_org
[Np Ns]=size(ppx);

%% Remove floaters
if(newEdata)
  findfloat
  save('float_info_ST','cc','allcc','ifl','infl','cwl','cwr','cwb');
end
load float_info_ST

DDD=repmat(sig/Lx,Ns,1)';
ppx(allcc<=2)=0;
ppy(allcc<=2)=.5-DDD(allcc<=2)/2;

%% get Unique states
if(newEdata)
  fc=100;
  FindUniq
  save('uniqN7nexp_ST_100.000000','state','matchs','NS','NN','NA','N','CutOff','D','order','uD');
end
load -mat uniqN7nexp_ST_100.000000

%% Remove unstable states

spx=[G/2*[1 -1] (Lx/D-1)/2*[1 -1] 0 G*[1 -1]];
spy=[sqrt(1+2*G)/2*[1 1]+G/2 sqrt((Lx/D-G)*(2+3*G-Lx/D))/2*[1 1]+G/2 G/2 G/2*[1 1]];

spx=spx*D/Lx;
spy=spy*D/Lx-.5;

ppx2=spx';
ppy2=spy';

ppx1=ppx(:,matchs(1:NS));
ppy1=ppy(:,matchs(1:NS));

NS1=NS;
NS2=1;
PhaseSpaceMatch
[sdd idd]=sort(dd);
pp=idd(1);
bad=find(state==pp);
good=setdiff(1:Ns,bad);
[junk junk gifl]=intersect(ifl,good);

if(newEdata)
  ppx=ppx(:,good);
  ppy=ppy(:,good);
  fc=100;
  FindUniq
  uppx=ppx(:,matchs(1:NS));
  uppy=ppy(:,matchs(1:NS));

  save('Exp_ST_FindUniq_corr','state','matchs','NS','NN','NA','N','CutOff','D','order','uD','uppx','uppy');
end
load Exp_ST_FindUniq_corr;
uDST=uD;

%%  Calculate unique states using average over all states

load alldataST_org;  % move floater back to original position for average;
ppx=ppx(:,good);
ppy=ppy(:,good);
ppx1=zeros(Np,NS);
ppy1=zeros(Np,NS);
for ns=1:NS
  kk=find(state==ns);
  jj=abs(order(:,kk))+Np*repmat(kk-1,Np,1);
  ppx1(:,ns)=mean(sign(order(:,kk)).*ppx(jj),2);
  ppy1(:,ns)=mean(ppy(jj),2);

  ii=find(allcc(:,good(kk(1)))<=2);
  if(~isempty(ii))
    for nii=1:length(ii);
      jj=abs(order(ii(nii),kk))+Np*(kk-1);
      ppx(jj)=sign(order(jj))*ppx1(ii(nii),ns);
      ppy(jj)=ppy1(ii(nii),ns);
    end
  end
end

ToYale('newexpstates_uniqST.txt',ppx1,ppy1,0,Lx/Lx,-.5,repmat(sig/Lx,length(ppx),1)');

[nn bb]=hist(state,1:NS);
[nns inns]=sort(nn,'descend');
ppx=ppx1(:,inns);
ppy=ppy1(:,inns);
save('squeeze_state_list','ppx','ppy','nns','inns','state','matchs','NS');

end
%% Error Handling
load('squeeze_state_list');
err=0;
snc=1;
statenums=[NS:NS];
save('pers','err','statenums','snc');
while(1); % try again no matter what

try
  
%% Clear All

clear all;
load('pers');

%% load state and squeeze

load('squeeze_state_list');
while(snc<=length(statenums))
  statenum=statenums(snc);
  mdyale007;
  snc=snc+1;
end

%% retry if error

catch
  fprintf('Error %d for state %d\n',err,statenum);
  err=err+1;
  snc=snc+1;
  save('pers','err','statenums','snc');
end
end
